#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "statements.h"
#include "keywords.h"
#include <math.h>

int main(int argc, char *argv[]) {
  char **statement;
  int i,j,k;
  int count=0;
  char *c;
  char *cod;
  char single;
  char code[500];
  char displaycode[500];
  int unnamed=0;
  FILE *header;
  int multiplespace=0;
  char *includes_file="default.inc";
  char *filename="2600basic_variable_redefs.h";
  
    // get command line arguments
  while ((i=getopt(argc, argv, "r:")) != -1) {
  switch (i) {
    case 'r':
        filename=(char *)malloc(100);
        strcpy(filename, optarg);    // root directory of server
        break;
    case '?':
        fprintf(stderr,"usage: %s -r <variable redefs file>\n",argv[0]);
        exit(1);
    }
  }

  optimization=0;
  smartbranching=0;
  line=0;
  numfixpoint44=0;
  numfixpoint88=0;
  numfors=0;
  numthens=0;
  numelses=0;
  numredefvars=0;
  numconstants=0;
  branchtargetnumber=0;
  doingfunction=0;

  header_open(header);
  init_includes();

  statement=(char **)malloc(sizeof(char*)*50);
  for (i=0;i<50;++i) {
    statement[i]=(char*)malloc(sizeof(char)*50);
  }

  while (1) { // clear out statement cache
    for (i=0;i<50;++i) {
      for (j=0;j<50;++j) {
        statement[i][j]='\0';
      }
    }
    c=fgets(code, 500, stdin); // get next line from input
    incline();
    strcpy(displaycode,code);
    if (!c) break; //end of file

// preprocessing removed in favor of a simplistic lex-based preprocessor

    i=0;j=0;k=0;

// look for spaces, reject multiples
    while(code[i]!='\0') {
      single=code[i++];
      if (single == ' ') {
	if (!multiplespace)
	{
          j++;
	  k=0;
	}
	multiplespace++;
      }
      else
      {
	multiplespace=0;
	statement[j][k++]=single;
      }

    }

    if (statement[0][0]=='\0')
    {
      sprintf(statement[0],"L0%d",unnamed++);
    }
    if (strncmp(statement[0],"end\0",3))
      printf(".%s ; %s\n",statement[0],displaycode); //    printf(".%s ; %s\n",statement[0],code);

//for (i=0;i<10;++i)fprintf(stderr,"%s ",statement[i]);

    keywords(statement);
  }
  printf("       echo \"    \",[(scoretable - *)]d , \"bytes of ROM space left\")\n");
  header_write(header, filename);
  create_includes(includes_file);
  fprintf(stderr,"2600 Basic compilation complete.\n");
  freemem(statement);
}
